| Bsoft 1.9 Bernard's software package

- Main Page
- Namespaces
- Classes
- Files

- File List
- File Members

Classes | Macros | Typedefs | Enumerations | Functions | Variables
jpeglib.h File Reference
`#include "jmorecfg.h"`
`#include "jpegint.h"`
`#include "jerror.h"`
`#include "jconfig.h"`

Go to the source code of this file.

## Classes
struct | JQUANT_TBL
struct | JHUFF_TBL
struct | jpeg_component_info
struct | jpeg_scan_info
struct | jpeg_marker_struct
struct | jpeg_common_struct
struct | jpeg_compress_struct
struct | jpeg_decompress_struct
struct | jpeg_error_mgr
struct | jpeg_progress_mgr
struct | jpeg_destination_mgr
struct | jpeg_source_mgr
struct | jpeg_memory_mgr

## Macros
#define | JPEG_LIB_VERSION 62 /* Version 6b */
#define | DCTSIZE 8 /* The basic DCT block is 8x8 samples */
#define | DCTSIZE2 64 /* DCTSIZE squared; # of elements in a block */
#define | NUM_QUANT_TBLS 4 /* Quantization tables are numbered 0..3 */
#define | NUM_HUFF_TBLS 4 /* Huffman tables are numbered 0..3 */
#define | NUM_ARITH_TBLS 16 /* Arith-coding tables are numbered 0..15 */
#define | MAX_COMPS_IN_SCAN 4 /* JPEG limit on # of components in one scan */
#define | MAX_SAMP_FACTOR 4 /* JPEG limit on sampling factors */
#define | C_MAX_BLOCKS_IN_MCU 10 /* compressor's limit on blocks per MCU */
#define | D_MAX_BLOCKS_IN_MCU 10 /* decompressor's limit on blocks per MCU */
#define | JDCT_DEFAULT JDCT_ISLOW
#define | JDCT_FASTEST JDCT_IFAST
#define | jpeg_common_fields
#define | JMSG_LENGTH_MAX 200 /* recommended size of format_message buffer */
#define | JMSG_STR_PARM_MAX 80
#define | JPOOL_PERMANENT 0 /* lasts until master record is destroyed */
#define | JPOOL_IMAGE 1 /* lasts until done with image/datastream */
#define | JPOOL_NUMPOOLS 2
#define | JPP(arglist) arglist
#define | jpeg_create_compress(cinfo)
#define | jpeg_create_decompress(cinfo)
#define | JPEG_SUSPENDED 0 /* Suspended due to lack of input data */
#define | JPEG_HEADER_OK 1 /* Found valid image datastream */
#define | JPEG_HEADER_TABLES_ONLY 2 /* Found valid table-specs-only datastream */
#define | JPEG_REACHED_SOS 1 /* Reached start of new scan */
#define | JPEG_REACHED_EOI 2 /* Reached end of image */
#define | JPEG_ROW_COMPLETED 3 /* Completed one iMCU row */
#define | JPEG_SCAN_COMPLETED 4 /* Completed last iMCU row of a scan */
#define | JPEG_RST0 0xD0 /* RST0 marker code */
#define | JPEG_EOI 0xD9 /* EOI marker code */
#define | JPEG_APP0 0xE0 /* APP0 marker code */
#define | JPEG_COM 0xFE /* COM marker code */

## Typedefs
typedef JSAMPLE FAR * | JSAMPROW
typedef JSAMPROW * | JSAMPARRAY
typedef JSAMPARRAY * | JSAMPIMAGE
typedef JCOEF | JBLOCK[DCTSIZE2]
typedef JBLOCK FAR * | JBLOCKROW
typedef JBLOCKROW * | JBLOCKARRAY
typedef JBLOCKARRAY * | JBLOCKIMAGE
typedef JCOEF FAR * | JCOEFPTR
typedef struct jpeg_marker_struct FAR * | jpeg_saved_marker_ptr
typedef struct jpeg_common_struct * | j_common_ptr
typedef struct jpeg_compress_struct * | j_compress_ptr
typedef struct jpeg_decompress_struct * | j_decompress_ptr
typedef struct jvirt_sarray_control * | jvirt_sarray_ptr
typedef struct jvirt_barray_control * | jvirt_barray_ptr

## Enumerations
enum | J_COLOR_SPACE { JCS_UNKNOWN, JCS_GRAYSCALE, JCS_RGB, JCS_YCbCr, JCS_CMYK, JCS_YCCK }
enum | J_DCT_METHOD { JDCT_ISLOW, JDCT_IFAST, JDCT_FLOAT }
enum | J_DITHER_MODE { JDITHER_NONE, JDITHER_ORDERED, JDITHER_FS }

## Functions
typedef | JMETHOD (boolean, jpeg_marker_parser_method,(j_decompress_ptr cinfo))
| EXTERN (struct jpeg_error_mgr *) jpeg_std_error JPP((struct jpeg_error_mgr *err))
| EXTERN (void) jpeg_CreateCompress JPP((j_compress_ptr cinfo
| EXTERN (int) jpeg_quality_scaling JPP((int quality))
| EXTERN (JQUANT_TBL *) jpeg_alloc_quant_table JPP((j_common_ptr cinfo))
| EXTERN (JHUFF_TBL *) jpeg_alloc_huff_table JPP((j_common_ptr cinfo))
| EXTERN (JDIMENSION) jpeg_write_scanlines JPP((j_compress_ptr cinfo
| EXTERN (jvirt_barray_ptr *) jpeg_read_coefficients JPP((j_decompress_ptr cinfo))

## Variables
int | version
int size_t | structsize
FILE * | outfile
FILE * | infile
J_COLOR_SPACE | colorspace
int | quality
int boolean | force_baseline
int | scale_factor
int | which_tbl
int const unsigned int * | basic_table
boolean | suppress
boolean | write_all_tables
JSAMPARRAY | scanlines
JSAMPARRAY JDIMENSION | num_lines
JSAMPIMAGE | data
int | marker
int const JOCTET * | dataptr
int const JOCTET unsigned int | datalen
int | val
boolean | require_image
JSAMPARRAY JDIMENSION | max_lines
int | scan_number
int | marker_code
int unsigned int | length_limit
int jpeg_marker_parser_method | routine
jvirt_barray_ptr * | coef_arrays
j_compress_ptr | dstinfo
int | desired

## Macro Definition Documentation

#define C_MAX_BLOCKS_IN_MCU 10 /* compressor's limit on blocks per MCU */

Definition at line 55 of file jpeglib.h.

#define D_MAX_BLOCKS_IN_MCU 10 /* decompressor's limit on blocks per MCU */

Definition at line 57 of file jpeglib.h.

#define DCTSIZE 8 /* The basic DCT block is 8x8 samples */

Definition at line 41 of file jpeglib.h.

#define DCTSIZE2 64 /* DCTSIZE squared; # of elements in a block */

Definition at line 42 of file jpeglib.h.

#define JDCT_DEFAULT JDCT_ISLOW

Definition at line 224 of file jpeglib.h.

#define JDCT_FASTEST JDCT_IFAST

Definition at line 227 of file jpeglib.h.

#define JMSG_LENGTH_MAX 200 /* recommended size of format_message buffer */

Definition at line 652 of file jpeglib.h.

#define JMSG_STR_PARM_MAX 80

Definition at line 660 of file jpeglib.h.

#define JPEG_APP0 0xE0 /* APP0 marker code */

Definition at line 1047 of file jpeglib.h.

#define JPEG_COM 0xFE /* COM marker code */

Definition at line 1048 of file jpeglib.h.

#define jpeg_common_fields

Value:
struct jpeg_error_mgr * err; /* Error handler module */\
struct jpeg_memory_mgr * mem; /* Memory manager module */\
struct jpeg_progress_mgr * progress; /* Progress monitor, or NULL if none */\
void * client_data; /* Available for use by application */\
boolean is_decompressor; /* So common code can tell which is which */\
int global_state /* For checking call sequence validity */
jpeg_error_mgr
Definition: jpeglib.h:643
jpeg_progress_mgr
Definition: jpeglib.h:701
jpeg_memory_mgr
Definition: jpeglib.h:756

Definition at line 241 of file jpeglib.h.

#define jpeg_create_compress | ( |  | cinfo | ) |

Value:
jpeg_CreateCompress((cinfo), JPEG_LIB_VERSION, \
(size_t) sizeof(struct jpeg_compress_struct))
jpeg_CreateCompress
jpeg_CreateCompress(j_compress_ptr cinfo, int version, size_t structsize)
Definition: jcapimin.c:30
JPEG_LIB_VERSION
#define JPEG_LIB_VERSION
Definition: jpeglib.h:33
jpeg_compress_struct
Definition: jpeglib.h:268

Definition at line 894 of file jpeglib.h.

#define jpeg_create_decompress | ( |  | cinfo | ) |

Value:
jpeg_CreateDecompress((cinfo), JPEG_LIB_VERSION, \
(size_t) sizeof(struct jpeg_decompress_struct))
JPEG_LIB_VERSION
#define JPEG_LIB_VERSION
Definition: jpeglib.h:33
jpeg_decompress_struct
Definition: jpeglib.h:411
jpeg_CreateDecompress
jpeg_CreateDecompress(j_decompress_ptr cinfo, int version, size_t structsize)
Definition: jdapimin.c:30

Definition at line 897 of file jpeglib.h.

#define JPEG_EOI 0xD9 /* EOI marker code */

Definition at line 1046 of file jpeglib.h.

#define JPEG_HEADER_OK 1 /* Found valid image datastream */

Definition at line 966 of file jpeglib.h.

#define JPEG_HEADER_TABLES_ONLY 2 /* Found valid table-specs-only datastream */

Definition at line 967 of file jpeglib.h.

#define JPEG_LIB_VERSION 62 /* Version 6b */

Definition at line 33 of file jpeglib.h.

#define JPEG_REACHED_EOI 2 /* Reached end of image */

Definition at line 997 of file jpeglib.h.

#define JPEG_REACHED_SOS 1 /* Reached start of new scan */

Definition at line 996 of file jpeglib.h.

#define JPEG_ROW_COMPLETED 3 /* Completed one iMCU row */

Definition at line 998 of file jpeglib.h.

#define JPEG_RST0 0xD0 /* RST0 marker code */

Definition at line 1045 of file jpeglib.h.

#define JPEG_SCAN_COMPLETED 4 /* Completed last iMCU row of a scan */

Definition at line 999 of file jpeglib.h.

#define JPEG_SUSPENDED 0 /* Suspended due to lack of input data */

Definition at line 965 of file jpeglib.h.

#define JPOOL_IMAGE 1 /* lasts until done with image/datastream */

Definition at line 749 of file jpeglib.h.

#define JPOOL_NUMPOOLS 2

Definition at line 750 of file jpeglib.h.

#define JPOOL_PERMANENT 0 /* lasts until master record is destroyed */

Definition at line 748 of file jpeglib.h.

#define JPP | ( |  | arglist | ) | arglist

Definition at line 818 of file jpeglib.h.

#define MAX_COMPS_IN_SCAN 4 /* JPEG limit on # of components in one scan */

Definition at line 46 of file jpeglib.h.

#define MAX_SAMP_FACTOR 4 /* JPEG limit on sampling factors */

Definition at line 47 of file jpeglib.h.

#define NUM_ARITH_TBLS 16 /* Arith-coding tables are numbered 0..15 */

Definition at line 45 of file jpeglib.h.

#define NUM_HUFF_TBLS 4 /* Huffman tables are numbered 0..3 */

Definition at line 44 of file jpeglib.h.

#define NUM_QUANT_TBLS 4 /* Quantization tables are numbered 0..3 */

Definition at line 43 of file jpeglib.h.

## Typedef Documentation

typedef struct jpeg_common_struct* j_common_ptr

Definition at line 261 of file jpeglib.h.

typedef struct jpeg_compress_struct* j_compress_ptr

Definition at line 262 of file jpeglib.h.

typedef struct jpeg_decompress_struct* j_decompress_ptr

Definition at line 263 of file jpeglib.h.

typedef JCOEF JBLOCK[DCTSIZE2]

Definition at line 70 of file jpeglib.h.

typedef JBLOCKROW* JBLOCKARRAY

Definition at line 72 of file jpeglib.h.

typedef JBLOCKARRAY* JBLOCKIMAGE

Definition at line 73 of file jpeglib.h.

typedef JBLOCK FAR* JBLOCKROW

Definition at line 71 of file jpeglib.h.

typedef JCOEF FAR* JCOEFPTR

Definition at line 75 of file jpeglib.h.

typedef struct jpeg_marker_struct FAR* jpeg_saved_marker_ptr

Definition at line 193 of file jpeglib.h.

typedef JSAMPROW* JSAMPARRAY

Definition at line 67 of file jpeglib.h.

typedef JSAMPARRAY* JSAMPIMAGE

Definition at line 68 of file jpeglib.h.

typedef JSAMPLE FAR* JSAMPROW

Definition at line 66 of file jpeglib.h.

typedef struct jvirt_barray_control* jvirt_barray_ptr

Definition at line 753 of file jpeglib.h.

typedef struct jvirt_sarray_control* jvirt_sarray_ptr

Definition at line 752 of file jpeglib.h.

## Enumeration Type Documentation

enum J_COLOR_SPACE

Enumerator
JCS_UNKNOWN |
JCS_GRAYSCALE |
JCS_RGB |
JCS_YCbCr |
JCS_CMYK |
JCS_YCCK |

Definition at line 206 of file jpeglib.h.

enum J_DCT_METHOD

Enumerator
JDCT_ISLOW |
JDCT_IFAST |
JDCT_FLOAT |

Definition at line 217 of file jpeglib.h.

enum J_DITHER_MODE

Enumerator
JDITHER_NONE |
JDITHER_ORDERED |
JDITHER_FS |

Definition at line 232 of file jpeglib.h.

## Function Documentation

EXTERN | ( | struct jpeg_error_mgr * |  | ) |

EXTERN | ( | void |  | ) |

EXTERN | ( | int |  | ) |

EXTERN | ( | JQUANT_TBL * |  | ) |

EXTERN | ( | JHUFF_TBL * |  | ) |

EXTERN | ( | JDIMENSION |  | ) |

EXTERN | ( | jvirt_barray_ptr * |  | ) |

typedef JMETHOD | ( | boolean | ,
|  | jpeg_marker_parser_method | ,
|  | (j_decompress_ptr cinfo) |
| ) |  |

## Variable Documentation

int const unsigned int* basic_table

Definition at line 924 of file jpeglib.h.

jvirt_barray_ptr* coef_arrays

Definition at line 1017 of file jpeglib.h.

J_COLOR_SPACE colorspace

Definition at line 917 of file jpeglib.h.

JSAMPIMAGE data

Definition at line 945 of file jpeglib.h.

int unsigned int datalen

Definition at line 950 of file jpeglib.h.

int const JOCTET* dataptr

Definition at line 950 of file jpeglib.h.

int desired

Definition at line 1038 of file jpeglib.h.

j_compress_ptr dstinfo

Definition at line 1019 of file jpeglib.h.

int const unsigned int int boolean force_baseline

Definition at line 919 of file jpeglib.h.

FILE* infile

Definition at line 911 of file jpeglib.h.

int unsigned int length_limit

Definition at line 1006 of file jpeglib.h.

int marker

Definition at line 950 of file jpeglib.h.

int marker_code

Definition at line 1006 of file jpeglib.h.

JSAMPIMAGE JDIMENSION max_lines

Definition at line 977 of file jpeglib.h.

JSAMPIMAGE JDIMENSION num_lines

Definition at line 939 of file jpeglib.h.

FILE* outfile

Definition at line 910 of file jpeglib.h.

int quality

Definition at line 919 of file jpeglib.h.

boolean require_image

Definition at line 963 of file jpeglib.h.

int jpeg_marker_parser_method routine

Definition at line 1011 of file jpeglib.h.

int const unsigned int int scale_factor

Definition at line 922 of file jpeglib.h.

int scan_number

Definition at line 989 of file jpeglib.h.

JSAMPARRAY scanlines

Definition at line 939 of file jpeglib.h.

int size_t structsize

Definition at line 901 of file jpeglib.h.

boolean suppress

Definition at line 931 of file jpeglib.h.

int val

Definition at line 956 of file jpeglib.h.

int version

Definition at line 901 of file jpeglib.h.

int which_tbl

Definition at line 924 of file jpeglib.h.

boolean write_all_tables

Definition at line 937 of file jpeglib.h.